local _G = GLOBAL
local SpawnPrefab = GLOBAL.SpawnPrefab
local Vector3 = GLOBAL.Vector3
local FRAMES = GLOBAL.FRAMES
local Prefabs = GLOBAL.Prefabs

local pigman_talkersay = GetModConfigData("meat_nettles")
local meat_nettles = GetModConfigData("meat_nettles") --女武神可以吃荨麻，荨麻是肉肉肉！

local jieduji_rou = {
    "cutnettle",
    "nettlelosange",
    --"",
}
if meat_nettles then
    for i,v in ipairs(jieduji_rou) do
        AddPrefabPostInit(v,function(inst)
            inst.components.edible.foodtype = "MEAT"
        end)
    end
end

local function talkersay(inst, text)
    if not pigman_talkersay or not inst or not text then return end
    inst:DoTaskInTime(0.05, function()
        if inst and inst:IsValid() and inst.components.talker then
            inst.components.talker:Say(text)
        end
    end)
end

local function chefinvitemslot(chefinv, itemprefab)
    for k = 1, chefinv.maxslots do
        local v = chefinv.itemslots[k]
        if v and v.prefab == itemprefab then
            return v
        end
    end
end

local function py_niaolong(giver,item,inst) --鸟笼fn
    local giverinv = giver.components.inventory
    local jinbix = 1
    local pyitemslots = nil
    if not giverinv then return jinbix end
    local chefinv = giverinv
    pyitemslots = chefinvitemslot(chefinv, item.prefab)
    local pyitem = giverinv.activeitem or pyitemslots
    local jinbiz = pyitem and pyitem.components.stackable and pyitem.components.stackable.stacksize or 0
    if pyitem then pyitem:Remove() end
    jinbix = jinbix + jinbiz
    return jinbix
end

local function py_fn(inst, giver, item, pyjb)
    local giverinv = giver.components.inventory
    local pybs = pyjb or 1
    local jinbix    = 0
    local jinbi_10  = 0
    local jinbi_100 = 0
    local jinbiy    = 0
    -- local PYx,PYy,PYz = giver.Transform:GetWorldPosition()
    -- local ents = TheSim:FindEntities(PYx,PYy,PYz,3)
    -- for k,v in pairs(ents) do
    --     if v.prefab == item.prefab then
    --         local duidie = v.components.stackable and v.components.stackable.stacksize or 1
    --         jinbix = jinbix + duidie * pybs
    --         v:Remove()
    --     end
    -- end
    jinbix = py_niaolong(giver,item,inst) * pybs

    jinbi_100 = math.floor(jinbix / 100)
    jinbi_10  = math.floor(jinbix / 10) - jinbi_100 * 10
    jinbiy    = jinbix - (jinbi_100 * 100 + jinbi_10 * 10)

    
    local jinbi_100_tal = jinbi_100 > 0 and jinbi_100.."枚百元猪币，" or ""
    local jinbi_10_tal  = jinbi_10  > 0 and jinbi_10.."枚十元猪币，" or ""
    local jinbiy_tal    = jinbiy    > 0 and jinbiy.."枚猪猪币，" or ""
    local text = "一共"..jinbi_100_tal..jinbi_10_tal..jinbiy_tal.."清点收好！"
    talkersay(inst, text)

    for i=1,jinbi_100 do
        giverinv:GiveItem(SpawnPrefab("oinc100"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
    end
    for i=1,jinbi_10 do
        giverinv:GiveItem(SpawnPrefab("oinc10"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
    end
    for i=1,jinbiy do
        giverinv:GiveItem(SpawnPrefab("oinc"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
    end
    if item then item:Remove() end
end

local function pyshang_oinc(inst, giver, item) --兑换呼噜币
    local giverinv = giver.components.inventory
    if item.prefab == "oinc" then
        local pyjb = 1
        py_fn(inst, giver, item, pyjb)
    elseif item.prefab == "oinc10" then --呼噜币10
        local jinbi_10  = 0
        local jinbi_100 = 0
        local PYx,PYy,PYz = giver.Transform:GetWorldPosition()
        local ents = TheSim:FindEntities(PYx,PYy,PYz,2)
        for k,v in pairs(ents) do
            if v.prefab == "oinc10" then
                local duidie = v.components.stackable and v.components.stackable.stacksize or 1
                jinbi_10 = jinbi_10 + duidie
                v:Remove()
            end
        end
        jinbi_100 = math.floor(jinbi_10 / 10)
        jinbi_10 = jinbi_10 - jinbi_100 * 10

        
        local jinbi_100_tal = jinbi_100 > 0 and jinbi_100.."枚百元猪币，" or ""
        local jinbi_10_tal  = jinbi_10.."枚十元猪币，"
        local text = "一共"..jinbi_100_tal..jinbi_10_tal.."清点收好！"
        talkersay(inst, text)

        for i=1,jinbi_10 do
            giverinv:GiveItem(SpawnPrefab("oinc10"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
        end
        for i=1,jinbi_100 do
            giverinv:GiveItem(SpawnPrefab("oinc100"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
        end
    elseif item.prefab == "oinc100" then --呼噜币100
        local jinbi_100 = 0
        local PYx,PYy,PYz = giver.Transform:GetWorldPosition()
        local ents = TheSim:FindEntities(PYx,PYy,PYz,3)
        for k,v in pairs(ents) do
            if v.prefab == "oinc100" then
                local duidie = v.components.stackable and v.components.stackable.stacksize or 1
                jinbi_100 = jinbi_100 + duidie
                v:Remove()
            end
        end

        local text = "一共"..jinbi_100.."枚百元猪币，清点收好！"
        talkersay(inst, text)

        for i=1,jinbi_100 do
            giverinv:GiveItem(SpawnPrefab("oinc100"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
        end
    elseif inst.prefab == "pigman_storeowner" or inst.prefab == "pigman_storeowner_shopkeep" then --碎叶交易
        local pyjb = 1
        py_fn(inst, giver, item, pyjb)
    elseif inst.prefab == "pigman_mayor_shopkeep" or inst.prefab == "pigman_mayor" then --镇长收金块
        local pyjb = 5
        py_fn(inst, giver, item, pyjb)
    elseif inst.prefab == "pigman_collector" or inst.prefab == "pigman_collector_shopkeep" then --齿轮老板收藏家
        local pyjb = 3
        if item.prefab == "relic_1" or item.prefab == "relic_2" or item.prefab == "relic_3" then
            pyjb = 10
        end
        py_fn(inst, giver, item, pyjb)
    else
        local Oldonaccept = inst.oldonaccept
        Oldonaccept(inst, giver, item)
    end
end

local function bird_anim(inst)
    inst.AnimState:PlayAnimation("peck")
    inst.AnimState:PushAnimation("peck")
    inst.AnimState:PushAnimation("peck")
    inst.AnimState:PushAnimation("hop")
    
    inst.AnimState:PushAnimation("idle_bird", true)
end

local can_accept_s = true
local function pyshang_jidan(inst, giver, item) --快速鸡蛋交易
    local giverinv = giver.components.inventory
    if inst.components.sleeper and inst.components.sleeper:IsAsleep() then
        inst.components.sleeper:WakeUp()
    end

    if item.components.edible then
        local seed_name = string.lower(item.prefab .. "_seeds")
        local can_accept = can_accept_s and (Prefabs[seed_name] or item.prefab == "seeds" or item.components.edible.foodtype == "MEAT")
        if can_accept then
            bird_anim(inst)
            if item.components.edible.foodtype == "MEAT" then
                local jinbix = py_niaolong(giver,item,inst)
                inst:DoTaskInTime(60*FRAMES, function() 
                    for i=1,jinbix do
                        giverinv:GiveItem(SpawnPrefab("bird_egg"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
                    end
                end)
            else
                if Prefabs[seed_name] then
                    local jinbix = py_niaolong(giver,item,inst)
                    inst:DoTaskInTime(60*FRAMES, function() 
                        for i=1,jinbix do 
                            local num_seeds = math.random(2)
                            for k = 1, num_seeds do
                                giverinv:GiveItem(SpawnPrefab(seed_name), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
                            end
                            
                            if math.random() < .5 then
                                giverinv:GiveItem(SpawnPrefab("seeds"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
                            end
                        end
                    end)
                else
                    inst:DoTaskInTime(60*FRAMES, function() inst.components.lootdropper:SpawnLootPrefab("seeds") end)
                end
            end
        elseif item.prefab == "rose" then --兼容mods -- workshop-1662258911 -- Legendary Gifts for Valentine's Day Reworked（情人节的传奇礼物）
            bird_anim(inst)
            local jinbix = py_niaolong(giver,item,inst)
            -- print("jinbix: "..jinbix)
            inst:DoTaskInTime(60*FRAMES, function()
                for i=1, jinbix do
                    local num2_seeds = math.random(2)
                    for k = 1, num2_seeds do
                        giverinv:GiveItem(SpawnPrefab("rose_seed"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
                    end
                    
                    if math.random() < .5 then
                        giverinv:GiveItem(SpawnPrefab("seeds"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
                    end
                end
            end)
        elseif item.prefab == "rose_seed" then
            bird_anim(inst)
            inst:DoTaskInTime(60*FRAMES, function()
                inst.components.lootdropper:SpawnLootPrefab(item.prefab)
            end)
        end
    end
end

local function pyshang_zhu(inst, giver, item) --快速猪王交易
    local giverinv = giver.components.inventory
    if item.components.tradable.goldvalue > 0 then
        inst.AnimState:PlayAnimation("cointoss")
        inst.AnimState:PushAnimation("happy")
        inst.AnimState:PushAnimation("idle", true)
        local beishu = item.components.tradable and item.components.tradable.goldvalue
        local jinbix = py_niaolong(giver,item,inst) * beishu
        inst:DoTaskInTime(20/30, function() 
            inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingThrowGold")
            for i=1,jinbix do
                giverinv:GiveItem(SpawnPrefab("goldnugget"), nil,  Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())))
            end
            -- for k = 1, item.components.tradable.goldvalue do
            --     local nug = SpawnPrefab("goldnugget")
            --     local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
            --     nug.Transform:SetPosition(pt:Get())
            --     local down = TheCamera:GetDownVec()
            --     local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
            --     --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
            --     local sp = math.random()*4+2
            --     nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
            --     nug.components.inventoryitem:OnStartFalling()
            -- end
        end)
        inst:DoTaskInTime(1.5, function() 
            inst.SoundEmitter:PlaySound("dontstarve/pig/PigKingHappy")
        end)
        inst.happy = true
        if inst.endhappytask then
            inst.endhappytask:Cancel()
        end
        inst.endhappytask = inst:DoTaskInTime(5, function()
            inst.happy = false
            inst.endhappytask = nil
        end)
    end
end

-- AddComponentPostInit("trader", function(Trader, inst)
--     function Trader:SetAcceptTest( fn )
--         self.test = fn
--     end
-- end)

local Pigman_Shang =
{
    "pigman_mayor",               --野外乱跑的镇长
    "pigman_mayor_shopkeep",      --镇长店内
    "pigman_storeowner",          --金发姐姐
    "pigman_storeowner_shopkeep", --金发姐姐店内
    "pigman_collector",           --齿轮店长
    "pigman_collector_shopkeep",  --齿轮店长店内
}

for k, v in pairs(Pigman_Shang) do
    AddPrefabPostInit(v,function(inst)
        inst.oldonaccept = inst.components.trader.onaccept
        inst.components.trader.onaccept = pyshang_oinc
    end)
end

AddPrefabPostInit("birdcage",function(inst)
    inst.oldonaccept = inst.components.trader.onaccept
    inst.components.trader.onaccept = pyshang_jidan
end)

AddPrefabPostInit("pigking",function(inst)
    inst.oldonaccept = inst.components.trader.onaccept
    inst.components.trader.onaccept = pyshang_zhu
end)

--添加一键烹饪  --读档控制台代码：StartNextInstance({reset_action=RESET_ACTION.LOAD_SLOT, save_slot = SaveGameIndex:GetCurrentSaveSlot()}, true)
local function cooker_num(chef,item) --烹饪计数
    local chefinv = chef.components.inventory
    local jinbix = 1
    local pyitemslots = nil
    if not chefinv then return jinbix end
    for k = 1,chefinv.maxslots do
        local v = chefinv.itemslots[k]
        if v and v.prefab == item.prefab then
            pyitemslots = chefinv.itemslots[k]
        end
    end
    local pyitem = chefinv.activeitem or pyitemslots
    local jinbiz = pyitem and pyitem.components.stackable and pyitem.components.stackable.stacksize or 0
    jinbix = jinbix + jinbiz
    return jinbix
end

local function cooker_item(chef,item) --检测烹饪物品
    local chefinv = chef.components.inventory
    local pyitemslots = nil
    if not chefinv then return item end
    -- pyitemslots = chefinvitemslot(chefinv, item.prefab)
    local pyitem = chefinv.activeitem
    return pyitem
end

AddComponentPostInit("cooker", function(Cooker, inst)
    Cooker.OldCookItemFn = Cooker.CookItem
    function Cooker:CookItem(item, chef)
        local itemcookable = item and item.components.cookable and true or false
        local newitem = itemcookable and item.components.cookable:Cook(self.inst, chef)
        local newiper = newitem and newitem.components.perishable and newitem.components.perishable:GetPercent()
        local itempre = newitem and newitem.prefab
        local giverinv = chef.components.inventory
        if itemcookable then
            _G.ProfileStatsAdd("cooked_"..item.prefab)
            if self.oncookitem then
                self.oncookitem(item, newitem)
            end
        end
        local itemnum = cooker_num(chef,item) or 1
        -- print(itemnum, newitem)
        if newiper and itempre then
            for i = 1, itemnum do
                local _item = cooker_item(chef,item)
                if _item and _item.components.cookable then
                    local _newitem = SpawnPrefab(itempre)
                    _newitem.components.perishable:SetPercent(newiper)
                    giverinv:GiveItem(_newitem, nil,  Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
                    if _item.components.stackable then
                        _item.components.stackable:Get(1):Remove()
                    else
                        _item:Remove()
                    end
                end
            end
        end
        if itemcookable then
            if self.inst.SoundEmitter then
                self.inst.SoundEmitter:PlaySound("dontstarve/wilson/cook")
            end
            return newitem
        end
        -- return Cooker:OldCookItemFn(item, chef)
    end
end)